/* KERNELS */

#ifdef CPP_MIXED_PREC
typedef float number;
#else
typedef double number;
#endif

enum {max_nb_stage=5};
extern number tauj[max_nb_stage];
extern number cslj[max_nb_stage][max_nb_stage], cflj[max_nb_stage][max_nb_stage];

void dynamico_init_params(void);

void dynamico_ARK_step(int nstep,
		       number *mass_col, number *rhodz, number *theta_rhodz, 
		       number *u, number *geopot, number *w,
		       number *theta, number *ps, number *pk, number *hflux, number *qv,
		       number *dmass_col, number *drhodz, number *dtheta_rhodz,
		       number *du_fast, number *du_slow,
		       number *dPhi_fast, number *dPhi_slow, 
		       number *dW_fast, number *dW_slow);

void dynamico_remap(number *rhodz, number *theta_rhodz, number *u);

/* KERNELS -> XIOS */
void dynamico_setup_xios(void);
void dynamico_xios_set_timestep(double);
void dynamico_xios_update_calendar(int);
/* CXIOS */
void cxios_context_close_definition(void);
void cxios_context_finalize(void);
void cxios_finalize(void);

void cxios_write_data_k81(char*, int, double*, int);
void cxios_write_data_k82(char*, int, double*, int, int);
void cxios_write_data_k83(char*, int, double*, int, int, int);
