from distutils.core import setup
from distutils.extension import Extension
from Cython.Build import cythonize

from ctypes import cdll, c_bool
libicosa = cdll.LoadLibrary('libicosa.so')
mixed_prec=c_bool.in_dll(libicosa, 'mixed_precision').value

if mixed_prec:
    extra_flags=["-DCPP_MIXED_PREC"]
else:
    extra_flags=None

setup(  name = "DYNAMICO kernels for unstructured mesh",
        ext_modules = cythonize([
            Extension("cxios",["cxios.pyx"],libraries=["xios"]),
            Extension("unstructured",["unstructured.pyx"],libraries=["icosa","xios"], extra_compile_args=extra_flags)
            ], compile_time_env={'CPP_MIXED_PREC': mixed_prec} )
        )
